package dev.shadowsoffire.apotheosis.ench.enchantments;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.EnchModuleEvents;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.projectile.ThrownTrident;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.registries.ForgeRegistries;

public class SpearfishingEnchant extends Enchantment {
  public SpearfishingEnchant() {
    super(Enchantment.Rarity.UNCOMMON, EnchantmentCategory.TRIDENT, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
  }
  
  public int m_6183_(int pEnchantmentLevel) {
    return 12 + (pEnchantmentLevel - 1) * 18;
  }
  
  public int m_6175_(int pEnchantmentLevel) {
    return 200;
  }
  
  public int m_6586_() {
    return 5;
  }
  
  public void addFishes(LivingDropsEvent e) {
    DamageSource src = e.getSource();
    Entity entity = src.m_7640_();
    if (entity instanceof ThrownTrident) {
      ThrownTrident trident = (ThrownTrident)entity;
      if ((trident.m_9236_()).f_46443_)
        return; 
      ItemStack triStack = ((EnchModuleEvents.TridentGetter)trident).getTridentItem();
      int level = triStack.getEnchantmentLevel(this);
      if (trident.f_19796_.m_188501_() < 3.5F * level) {
        LivingEntity livingEntity = e.getEntity();
        e.getDrops().add(new ItemEntity(trident.m_9236_(), livingEntity.m_20185_(), livingEntity.m_20186_(), livingEntity.m_20189_(), new ItemStack((ItemLike)ForgeRegistries.ITEMS
                .tags().getTag(Apoth.Tags.SPEARFISHING_DROPS).getRandomElement(trident.f_19796_).orElse(Items.f_41852_), 1 + trident.f_19796_.m_188503_(3))));
      } 
    } 
  }
}
